#!/usr/bin/env python
#-*- coding:iso-8859-1 -*-


from time import sleep
import gtk
import gtk.glade
import gobject
import xmlrpclib
from StringIO import StringIO
from eolepack import eolepackdb
from socket import error as socketerror
import thread
import os
import locale, gettext, codecs
from ConfigParser import ConfigParser

##  voir pour compatibilit WindoZ
#os.environ['LC_ALL'] = "fr_FR"
#os.environ['LC_MESSAGES'] = "fr_FR"
#os.environ['LANG'] ='fr_FR'
#os.environ['LANGUAGE'] ='fr'
#locale.setlocale(locale.LC_ALL, 'fr_FR')

APP = 'edif'
DIR = 'i18n'
#DIR_GTK = 'i18n/fr-gtk'

gettext.bindtextdomain (APP, DIR)
gettext.textdomain (APP)
# installons la fonction _() dans les builtins
gettext.install (APP, DIR, unicode=1)

gtk.glade.bindtextdomain (APP,DIR)
gtk.glade.textdomain (APP)

# FIXME ugly hack to force dialogs to be displayed
# before running high load tasks
def rundial(dialog):
    dialog.set_keep_above(True)
    dialog.show()
    gobject.timeout_add(200,stop_timeout,dialog)
    dialog.run()

def stop_timeout(dialog,*args):
    dialog.response(gtk.RESPONSE_NONE)
    # return false to stop the timeout loop
    return False


# class managing specific spell configuration
class ConfSpell(ConfigParser):

    def __init__(self):
        ConfigParser.__init__(self)
        # determination of config file location
        self.model = None

    def load(self, string_io):
        """loads configuration data from a string_io
        """
        # loads configuration
        self.string_io = string_io
        self.readfp(self.string_io)
        try:
            self.destroys = eval(self.get('destroy','destroy'))
        except:
            # no data or bad data syntax
            self.destroys = []
        try:
            self.optionals = eval(self.get('optional','optional'))
        except:
            self.optionals = []
        try:
            self.devel = self.has_section('develpack')
        except:
            self.devel = False
        # update treemodel if any
        if self.model:
            self.model.clear()
            # ajout des catgories dans l'arbre
            self.iter_destroys = self.model.append(None)
            self.model.set_value(self.iter_destroys,0,_('destroys'))
            self.model.set_value(self.iter_destroys,1,'')
            self.iter_optionals = self.model.append(None)
            self.model.set_value(self.iter_optionals,0,_('optionals'))
            self.model.set_value(self.iter_optionals,1,'')

            for file_dest in self.destroys:
                add_iter = self.model.append(self.iter_destroys)
                self.model.set_value(add_iter,0,file_dest)
                self.model.set_value(add_iter,1,'destroy')
            for optional in self.optionals:
                add_iter = self.model.append(self.iter_optionals)
                self.model.set_value(add_iter,0,optional)
                self.model.set_value(add_iter,1,'optional')

    def set_model(self, treestore):
        """attach and initializes a GtkTreeStore
        """
        self.model = treestore

    def add_destroy(self, destroy):
        """adds a file/dir to destroy in the binary package
        """
        if destroy not in self.destroys:
            self.destroys.append(destroy)
            if self.model:
                add_iter = self.model.append(self.iter_destroys)
                self.model.set_value(add_iter,0,destroy)
                self.model.set_value(add_iter,1,'destroy')

    def add_optional(self, optional):
        """adds an optional dependency
        """
        if optional not in self.optionals:
            self.optionals.append(optional)
            if self.model:
                add_iter = self.model.append(self.iter_optionals)
                self.model.set_value(add_iter,0,optional)
                self.model.set_value(add_iter,1,'optional')

    def update_devel(self, devel):
        if devel != self.devel:
            self.devel = devel
            if self.devel == True:
                self.add_section('develpack')
            else:
                self.remove_section('develpack')
   
    def remove_iter(self, iter_del):
        """removes an item from the model"""
        if self.model:
            type_item = self.model.get_value(iter_del,1)
            value = self.model.get_value(iter_del,0)
            if type_item == 'destroy':
                self.destroys.remove(value)
            elif type_item == 'optional':
                self.optionals.remove(value)
            else:
                return
            self.model.remove(iter_del)
            
    def del_destroy(self, destroy):
        self.destroys.remove(destroy)

    def del_optional(self, optional):
        self.destroys.remove(optional)

    def get_conf(self):
        """returns configuration data
        @return: tuple(destroys, optionals) where
        destroys : files to delete in the binary paquet
        optionals : optional dependencies
        devel : devel packages
        """
        if self.filename is None:
            raise Exception(_('No configuration file defined'))
        return (self.destroys,self.optionals, self.devel)

    def update_conf(self):
        """updates config file with given options
        """
        # update data
        if not self.has_section('destroy'):
            self.add_section('destroy')
        if not self.has_section('optional'):
            self.add_section('optional')
        self.set('destroy','destroy',str(self.destroys))
        self.set('optional','optional',str(self.optionals))
        # returns sections
        try:
            self.string_io.seek(0)
            self.write(self.string_io)
        except:
            raise Exception(_('Error, could not write config file'))
        self.string_io.seek(0)
        return self.string_io.read()

        
class Edif:
    """Interface de gestion des releases et modules
    """

    #############################
    # Fonctions d'initialisation
    
    def __init__(self, gladefile, rel=False, fileconf="eolebase.conf", rc_file=None):
        """initialisation de l'interface
        """
        #######################
        ### lecture des options
        self.options = ConfigParser()
        self.options.read(fileconf)
        ######################
        ### variables internes
        # self.rel : indique si on dite une release (True) ou un module
        self.rel = rel
        # variable indiquant si des modifications non enregistres existent
        self.need_save = False
        # listes des modules et releases crs lors de la session d'application
        self.new_modules = []
        self.new_release = []
        self.last_paquets = {}
        # module en cours d'dition
        self.edited_module = None
        # diteur de fichier deconfiguration
        self.conf_parser = ConfSpell()
        # serveur xmlrpc distant (compilation)
        serv_addr = self.options.get('compilation','host')
        serv_port = self.options.get('compilation','port')
        self.compiler = xmlrpclib.ServerProxy('http://%s:%s' % (serv_addr, serv_port))
        ###################################
        ### initialisation du fichier glade
        if rc_file != None:
            gtk.rc_parse(rc_file)
        self.search_iter = None
        self.reached_previous = None
        self.widgets = gtk.glade.XML(gladefile)
        # dfinition des callbacks pour les signaux dfinis dans glade
        callbacks = {'on_EDIF_delete_event':self.quit,
                     'on_button_mode_toggled':self.toggle_mode,
                     'on_composants_button_press_event':self.toggle_composant,
                     'on_new_left_clicked':self.add_module,
                     'on_del_left_clicked':self.del_module,
                     'on_commit_clicked':self.commit,
                     #'on_dropbox_button_press_event':self.expand_tree,
                     'on_rollback_clicked':self.rollback,
                     'on_button_iso_clicked':self.create_iso,
                     'on_button_compile_clicked':self.do_compile,
                     'on_button_config_clicked':self.do_config,
                     'on_button_find_clicked':self.search,
                     'on_button_next_clicked':(self.search,True),
                     'on_conf_destroy_clicked':self.add_destroy,
                     'on_conf_optional_clicked':self.add_optional,
                     'on_conf_del_clicked':self.del_option,
                     'on_valid_conf_clicked':self.valid_conf,
                     'on_cancel_conf_clicked':self.hide_conf,
                     'on_conf_box_delete_event':self.hide_conf,
                    }
        self.widgets.signal_autoconnect(callbacks)
        ################################################
        ### accesseurs pour les widgets souvent utiliss
        self.mainwindow = self.widgets.get_widget('EDIF')
        # fentre de gestion des fichiers de config des spells
        self.confbox = self.widgets.get_widget('conf_box')
        self.conftree = self.widgets.get_widget('tree_conf')
        self.confcombo = self.widgets.get_widget('combo_depends')
        # module_tree : affiche les modules et releases
        self.module_tree = self.widgets.get_widget('modules')
        # comp_tree : affiche les composants et paquets
        self.comp_tree = self.widgets.get_widget('composants')
        self.comp_tree.set_sensitive(False)
        # dropbox : affiche les composants(paquets) du module(release) dit
        self.dropbox = self.widgets.get_widget('dropbox')
        self.dropbox.set_sensitive(False)
        self.dropbox.get_selection().connect('changed', self.expand_tree)
        self.status = self.widgets.get_widget('status')
        self.add_mod_box = self.widgets.get_widget('add_mod_box')
        self.add_rel_box = self.widgets.get_widget('add_rel_box')
        self.mod_selection = self.module_tree.get_selection()
        self.comp_selection = self.comp_tree.get_selection()
        # callback a appeler lors du clic sur un module ou une release
        self.mod_selection.connect('changed', self.update_module_name)
        ################################
        ### initialisation des treeviews
        self.set_label_title(_("Editing modules"), "#2B57D9")
        self.init_module()
        self.init_composants()
        self.init_dropbox()
        self.init_confbox()
        self.relmode()
        self.toggle_mode(self.widgets.get_widget('button_mode'))
        self.thread_finished = False
    
    def toggle_mode(self, button, *args):
        """callback appel lors d'un click sur le bouton de mode
        passe du mode release au mode module et vice-versa
        """
        self.update_status("")
        if self.need_save == True:
            dial = self.display_popup(_("Changes not commited, continue ?"), 'Confirm')
            response = dial.run()
            dial.destroy()
            if response == gtk.RESPONSE_NO:
                return False
        label = self.widgets.get_widget('label_mode')
        if button.get_active() == True:
            self.relmode()
            label.set_text(_("edit modules"))
            self.set_label_title(_("Editing releases"), "#c9513d")
        else:
            self.comp_tree.set_sensitive(False)
            self.modulemode()
            label.set_text(_("edit releases"))
            self.set_label_title(_("Editing modules"), "#2B57D9")
        
    def modulemode(self, *args):
        """initialisation du mode 'gestion de modules'
        """
        popup = self.display_popup(_("Importing Module List"), 'Message')
        rundial(popup)
        self.rel = False
        self.mainwindow.set_title(_("EDIF: Module Edition Mode"))
        self.dropbox.get_model().clear()
        self.update_module()
        self.update_composants()
        popup.destroy()
        self.widgets.get_widget('button_iso').set_sensitive(False)
        
    def relmode(self, *args):
        """initialisation du mode 'gestion de releases'
        """
        popup = self.display_popup(_("Importing Release List"), 'Message')
        rundial(popup)
        self.rel = True
        self.mainwindow.set_title(_("EDIF: Release Edition Mode"))
        self.dropbox.get_model().clear()
        self.update_module()
        self.comp_tree.get_model().clear()
        self.update_composants(fill=False)
        popup.destroy()
        self.widgets.get_widget('button_iso').set_sensitive(False)

    ##############################
    # initialisation des treeviews

    def init_module(self):
        """treeview des modules/releases
        
        colonne 0 = id_module/id_release
        colonne 1 = libelle_mod/libelle_mod+vers_majeure+vers_mineure
        """
        model = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING)
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn('module', renderer, text=1)
        self.module_tree.append_column(column)
        
        self.module_tree.set_model(model)

    def init_composants(self):
        """treeview des composants/paquets
        
        colonne 0 = index
        colonne 1 = libelle
        colonne 2 = checkbox avec attribut li sur col 3 et 7
        colonne 3 = Boolean -> 2
        colonne 4 = description (champ 4 model)
        colonne 5 = version
        colonne 6 = revision
        colonne 7 = Boolean : checkbox col 2 grise si True (composant dsactiv)
        colonne 8 = nom du composant si paquet
        """
        model = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING, gobject.TYPE_BOOLEAN, gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
        # cration des colonnes
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_('componants'), renderer, text=1)
        column.add_attribute(renderer, "foreground", 7)
        # TODO : essayer de colorier toute la ligne
        self.comp_tree.append_column(column)
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn(_('selection'), renderer, active=2)
        # on stocke l'attribut visible des checkboxs dans la colonne 4
        # pour pouvoir les cacher dans les parties non terminales de l'arbre
        column.add_attribute(renderer, "visible", 3)
        self.comp_tree.append_column(column)
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_('description'), renderer, text=4)
        column.add_attribute(renderer, "foreground", 7)
        self.comp_tree.append_column(column)
        # activation de la recherche sur le libelle
        self.comp_tree.set_search_column(1)
        self.comp_tree.set_model(model)

    def make_pb(self, column, cell, model, iter):
        """used to create pixmaps in a treeview column"""
        stock = model.get_value(iter, 4)
        pb = tree.render_icon(stock, gtk.ICON_SIZE_MENU, None)
        cell.set_property('pixbuf', pb)
        return

    def init_dropbox(self):
        """ treeview des composants/paquets slectionns

        colonne 0 = index
        colonne 1 = libelle
        colonne 2 = famille
        colonne 3 = iter correspondant dans comp_tree
        colonne 4 = image indiquant l'tat.
        """
        model = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT, gobject.TYPE_STRING)
        # cration des colonnes
        renderer = gtk.CellRendererPixbuf()
        column = gtk.TreeViewColumn(_('status'), renderer)
        if gtk.gtk_version[1] < 2:
            column.set_cell_data_func(renderer, self.make_pb)
        else:
            column.set_attributes(renderer, stock_id=4)
        self.dropbox.append_column(column)
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_('elements'), renderer, text=1)
        self.dropbox.append_column(column)
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_('family'), renderer, text=2)
        self.dropbox.append_column(column)
        # tri alphabtique et recherche sur le nom de composant
        model.set_sort_column_id(1, gtk.SORT_ASCENDING)
        self.dropbox.set_search_column(1)
        self.dropbox.set_model(model)
        self.dropbox.set_headers_clickable(True)

    def init_confbox(self):
        """initialise la fentre d'dition du fichier de config d'un composant
        """
        model = gtk.TreeStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
        # cration de la colonne
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn('items', renderer, text=0)
        self.conftree.append_column(column)
        self.conftree.set_model(model)
        self.conf_parser.set_model(model)
        # initialisation combobox
        modeldep = gtk.ListStore(gobject.TYPE_STRING)
        self.confcombo.set_model(modeldep)
        self.confcombo.set_text_column(0)

        
    ###########################
    # remplissage des treeview

    def update_module(self):
        """ remplit la liste des modules/paquets
        """
        self.modules = eolepackdb.get_module()
        model = self.module_tree.get_model()
        # supression des donnes prcdentes
        model.clear()
        for module in self.modules:
            # insertion d'un module
            mod_iter = model.insert_before(None, None)
            model.set_value(mod_iter, 0, module[0])
            model.set_value(mod_iter, 1, module[1])
            if self.rel == True:
                releases = eolepackdb.get_release_from_module(module[0])
                for rel in releases:
                    # insertion d'une release
                    rel_iter = model.insert_before(mod_iter, None)
                    model.set_value(rel_iter, 0, rel[0])
                    model.set_value(rel_iter, 1, module[1]+'-'+str(rel[2])+'.'+str(rel[3]))

    def update_composants(self, fill=True):
        """ remplit la liste des composants/paquets sous forme arborescente
        famille/composant(/paquet)
        """
        # rcupration des familles de composants
        self.familles = eolepackdb.get_famille()
        # rcupration de tous les composants par famille
        self.composants = eolepackdb.get_all_composant_from_famille()
        self.mod_composants = {}
        comp_modules = eolepackdb.get_all_composant_from_module()
        for mod, comps in comp_modules.items():
            # cration d'un dictionnaire {composant : status} pour chaque module
            mod_comps={}
            for comp in comps:
                mod_comps[comp[1]] = comp[2]
            self.mod_composants[mod] = mod_comps
        if fill:
            self.fill_tree_comp()

    def fill_tree_comp(self, release=None):
        # mise  jour de l'interface
        model = self.comp_tree.get_model()
        # on vide l'arbre
        model.clear()
        # recherche du module correspondant  la release
        module = None
        # on rinitialise la liste des derniers paquets
        for fam in self.familles:
            # insertion d'une famille
            fam_iter = model.insert_before(None, None)
            model.set_value(fam_iter, 0, fam[0])
            model.set_value(fam_iter, 1, fam[1])
            model.set_value(fam_iter, 2, False)
            model.set_value(fam_iter, 3, False)
            fam_ok = 0
            comp_not_valid = 0

            for comp in self.composants[fam[0]]:
                comp_ok = 1
                if release != None and self.rel == True:
                    # recherche du module correspondant
                    if release != None and self.rel == True:
                        if comp[0] not in self.mod_composants[release].keys():
                            comp_ok = 0
                        else:
                            if self.mod_composants[release][comp[0]] == 2:
                                # composant dsactiv dans ce module
                                comp_ok = 2
                            elif self.mod_composants[release][comp[0]] == 0:
                                # composant non valid
                                comp_ok = 3
                    else:
                        comp_ok = 0
                if comp_ok != 0:
                    fam_ok = 1
                    # insertion d'un composant (sauf en mode release si pas de paquets)
                    comp_iter = model.insert_before(fam_iter, None)
                    model.set_value(comp_iter, 0, comp[3])
                    model.set_value(comp_iter, 1, comp[0])
                    desc = unicode(comp[1], 'iso-8859-1').encode('UTF-8')
                    model.set_value(comp_iter, 4, desc)
                    if comp_ok == 2:
                        # composant dsactiv (supprim du module mais utilis dans des releases anciennes)
                        print  "%s dsactiv" % comp[0]
                        model.set_value(comp_iter, 7, 'red')
                    elif comp_ok == 3:
                        # composant non valid
                        print "%s non valid" % comp[0]
                        model.set_value(comp_iter, 7, 'black')
                        comp_not_valid = 1
                    else:
                        model.set_value(comp_iter, 7, 'green')
                    if self.rel == True:
                        paquets = eolepackdb.get_paquet_from_composant(comp[0])
                        # mode release -> on dsactive la checkbox pour le composant
                        model.set_value(comp_iter, 3, False)
                        # pas de paquets, on passe la famille et le paquet en rouge
                        if len(paquets) == 0:
                            self.last_paquets[paq[0]]=''
                            model.set_value(paq_iter, 7, 'black')
                            comp_not_valid = 1
                        else:
                            paq = paquets[0]
                            # on stocke la version du dernier paquet pour un usage ultrieur
                            self.last_paquets[paq[0]]='-'.join([paq[0],paq[1],str(paq[2])])
                        if comp_ok != 2:
                            # si dsactiv, on n'affiche pas les paquets
                            for paq in paquets:
                                # ajout d'un paquet
                                paq_iter = model.insert_before(comp_iter, None)
                                model.set_value(paq_iter, 0, 1)
                                model.set_value(paq_iter, 1, '-'.join([paq[0],paq[1],str(paq[2])]))
                                model.set_value(paq_iter, 2, False)
                                model.set_value(paq_iter, 3, True)
                                model.set_value(paq_iter, 5, paq[1])
                                model.set_value(paq_iter, 6, paq[2])
                                model.set_value(paq_iter, 7, 'black')
                                model.set_value(paq_iter, 8, paq[0])
                    else:
                        # mode module -> checkbox sur le composant
                        model.set_value(comp_iter, 3, True)

            if comp_not_valid == 1:
                model.set_value(fam_iter, 7, 'orange')
            else:
                model.set_value(fam_iter, 7, 'green')
            if fam_ok == 0:
                # pas de composants, on enlve la famille
                model.remove(fam_iter)

    #############################
    # manipulation des treeviews

    def update_module_name(self, selection, *args):
        """mise  jour de l'appli lors d'un clic sur un module/release
        """
        self.update_status("")
        # on rcupre la ligne slectionne
        (store, itersel) = selection.get_selected()
        if itersel is None:
            return

        self.comp_tree.set_sensitive(True)
        self.dropbox.set_sensitive(True)
        sel = store.get_value(itersel, 0)
        self.edited_module = sel
        if self.rel == True:
            # en mode release, on vrifie si on n'a pas selectionn un module
            # (si pas de parent dans l'arborescence, on ne fait rien)
            parent = store.iter_parent(itersel)
            if parent == None:
                return

        # on vide la liste des composants/paquets slectionns
        drop_model = self.dropbox.get_model()
        drop_model.clear()
        comp_model = self.comp_tree.get_model()
        popup = self.display_popup(_("Updating Components"), 'Message')
        rundial(popup)

        if self.rel == True:
            self.set_label_title(_("Editing release %s") % store.get_value(itersel, 1), "#c9513d")
        else:
            self.set_label_title(_("Editing module %s") % store.get_value(itersel, 1), "#2B57D9")
    
        if self.rel == True:
            # on rcupre le module associ  la release
            rel_mod = store.get_value(parent, 0)
            self.fill_tree_comp(rel_mod)
            self.widgets.get_widget('button_iso').set_sensitive(True)

        if self.rel == True:
            # on rcupre la liste des paquets pour la release
            ret_list = eolepackdb.get_paquet_from_release(sel)
            comps = [element[1] for element in ret_list]
            # recherche des composants dont aucun paquet n'est slectionn
            mod_list = [mod[1] for mod in eolepackdb.get_composant_from_module(rel_mod)]
            paq_list = [paq[1] for paq in ret_list]
            bad_comp = []
            for mod in mod_list:
                if mod not in comps:
                    bad_comp.append(mod)
#            for paq in paq_list:
#                if paq not in mod_list:
#                    bad_comp.append(paq)
                                        
            comp_list = [element[1]+'-'+element[2]+'-'+str(element[3]) for element in ret_list]
        else:
            # on rcupre la liste des composants pour le module
            ret_list = eolepackdb.get_composant_from_module(sel)
            comp_list = [element[1] for element in ret_list]
                        
        # on lance la recherche des composants/paquets de ce module/release
        cur_iter = comp_model.get_iter_root()
        self.run_tree(comp_model, comp_list, cur_iter, drop_model)
        if self.rel and bad_comp != []:
            cur_iter = comp_model.get_iter_root()
            self.run_tree_errs(comp_model, bad_comp, cur_iter, drop_model)
        
        popup.destroy()

    def run_tree_errs(self, model, list, cur_iter, drop_model):
        """ajoute dans dropbox des lignes pour les composants
        dont aucun paquet n'est slectionn
        """
        # boucle tant qu'il reste des items sur ce niveau
        while cur_iter != None:
            name = model.get_value(cur_iter, 1)
            fam_iter = cur_iter
            while model.iter_parent(fam_iter) != None:
                fam_iter=model.iter_parent(fam_iter)
            fam = model.get_value(fam_iter, 1)
            # si ce composant/paquet est dans la liste
            if name in list:
                # on met un composant avec icone d'erreur dans dropbox
                dr_iter = drop_model.append(None)
                drop_model.set_value(dr_iter, 1, name)
                drop_model.set_value(dr_iter, 2, fam)
                drop_model.set_value(dr_iter, 3, cur_iter)
                drop_model.set_value(dr_iter, 4, gtk.STOCK_STOP)

            self.run_tree_errs(model, list, model.iter_children(cur_iter), drop_model)
            # passage  l'item suivant du mme niveau
            cur_iter = model.iter_next(cur_iter)
        return True

    def run_tree(self, model, list, cur_iter, drop_model):
        """ met  jour l'arborescence des paquets /composants en fonction du module
        @param list: composants/paquets  slectionner
        """
        if cur_iter != None:
            # boucle tant qu'il reste des items sur ce niveau
            while cur_iter != None:
                # si le composant a une checkbox
                if model.get_value(cur_iter, 3):
                    name = model.get_value(cur_iter, 1)
                    fam_iter = cur_iter
                    while model.iter_parent(fam_iter) != None:
                        fam_iter=model.iter_parent(fam_iter)
                    fam = model.get_value(fam_iter, 1)
                    # si ce composant/paquet est dans la liste
                    if name in list:
                        # on coche la checkbox
                        model.set_value(cur_iter, 2, True)
                        # ajout  la liste des composants selectionns
                        dr_iter = drop_model.append(None)
                        drop_model.set_value(dr_iter, 1, name)
                        drop_model.set_value(dr_iter, 2, fam)
                        drop_model.set_value(dr_iter, 3, cur_iter)
                        # histoire de ralentir l'affaire on regarde si on met la petite croix :)
                        if self.rel != True:
                            # en mode module, avertissement si pas de paquets dans la base
                            if eolepackdb.get_paquet_from_composant(name) == []:
                                drop_model.set_value(dr_iter, 4, gtk.STOCK_STOP)
                        else:
                            # mode release : indicateur si ancienne version
                            comp_name = model.get_value(cur_iter, 8)
                            if self.last_paquets[comp_name] != name:
                                drop_model.set_value(dr_iter, 4, gtk.STOCK_GO_UP)
                    else:
                        # sinon, on le dsactive
                        model.set_value(cur_iter, 2, False)
                else:
                    # sinon, on r-apelle la fonction sur le niveau suivant
                    self.run_tree(model, list, model.iter_children(cur_iter), drop_model)
                # passage  l'item suivant du mme niveau
                cur_iter = model.iter_next(cur_iter)
        return True

    def search(self, button, bool_next=False):
        """recherche une occurence de composant dans le treeview
        """
        # on lit le texte  chercher
        pattern = self.widgets.get_widget('entry_find').get_text()
        if pattern == '':
            return
        model = self.comp_tree.get_model()
        if bool_next == True and self.search_iter != None:
            prev_path = self.search_iter
            self.reached_previous = False
        else:
            self.reached_previous = True
        iter_start = model.get_iter_root()
        res = self.find_item(model, {1:pattern}, search_iter=iter_start,approx=True)
        if bool_next == True:
            if self.search_iter != None:
                if prev_path == self.search_iter:
                    dial = self.display_popup(_("End of search"), 'Error')
                    response = dial.run()
                    dial.destroy()
                    return
        if res != None:
            self.expand_to_iter(self.comp_tree.get_model(), res)
        else:
            dial = self.display_popup(_("Pattern not found"), 'Error')
            response = dial.run()
            dial.destroy()
            


    def find_item(self, model, data, search_iter, depth=None, approx=False):
        """recherche une donne particulire dans un TreeStore
        @param model: TreeStore  parcourir
        @param data: Les donnes  rechercher (dictionnaire colonne : valeur)
        @param index: colonne ou rechercher la donne dans la ligne
        @param start_iter: iter ou commencer la recherche (None pour partir de root)
        @param depth: profondeur  laquelle se trouve la donne
        @return: le TreeIter correspondant ou None si non trouv
        """
        result = None
        # on dtermine la profondeur actuelle
        if search_iter == None:
            return None
        else:
            actual_depth = model.iter_depth(search_iter)
        while search_iter != None:
            # si on est au niveau de recherche demand (ou pas de niveau prcis)
            if depth == None or actual_depth == depth:
                # on recherche la donne
                if not self.reached_previous:
                    if model.get_path(search_iter) == self.search_iter:
                        self.reached_previous = True
                else:
                    data_iter = {}
                    for col in data.keys():
                        data_iter[col] = model.get_value(search_iter, col)
                    if not approx:
                        if data_iter == data:
                            self.search_iter = model.get_path(search_iter)
                            return search_iter
                    else:
                        # recherche de sous-chaines (ne chercher que des valeurs textuelles)
                        for val in data_iter.keys():
                            if data_iter[val].startswith(data[val]):
                                self.search_iter = model.get_path(search_iter)
                                return search_iter

            if actual_depth != depth or depth == None:
                # sinon, on recherche  la profondeur suivante
                childs_iter = self.find_item(model,
                                             data,
                                             search_iter=model.iter_children(search_iter),
                                             depth=depth,
                                             approx=approx)
                # si la donne est trouve dans les fils, on la retourne
                if childs_iter != None:
                    return childs_iter
            # iter suivant dans le mme niveau
            search_iter = model.iter_next(search_iter)

        # on n'a rien trouv
        return None

    def remove_dropbox(self, name):
        """supprime un lment de dropbox
        """
        self.update_status("")
        drop_model = self.dropbox.get_model()
        cur_iter = drop_model.get_iter_first()
        # on recherche l'lement dans la liste dropbox
        while cur_iter != None:
            # cas ou aucun paquet n'tait slectionn
            if name.startswith(drop_model.get_value(cur_iter, 1)) and drop_model.get_value(cur_iter, 4) == gtk.STOCK_STOP:
                next_iter = drop_model.iter_next(cur_iter)
                drop_model.remove(cur_iter)
                cur_iter = next_iter
            elif drop_model.get_value(cur_iter, 1) == name:
                # on le supprime de la vue
                drop_model.remove(cur_iter)
                if self.rel == False:
                    # suppression dans la base
                    eolepackdb.del_composant_from_module(self.edited_module, name)
                cur_iter= None
            else:
                cur_iter = drop_model.iter_next(cur_iter)

    def append_dropbox(self, name, fam, comp_iter, nopack=None):
        """ajout d'un lment dans dropbox
        """
        drop_model = self.dropbox.get_model()
        add_iter = drop_model.append(None)
        drop_model.set_value(add_iter, 1, name)
        drop_model.set_value(add_iter, 2, fam)
        drop_model.set_value(add_iter, 3, comp_iter)
        if nopack != None:
            drop_model.set_value(add_iter, 4, gtk.STOCK_STOP)
        else:
            comp_name = self.comp_tree.get_model().get_value(comp_iter,8)
            if self.rel == True:
                if self.last_paquets[comp_name] != name:
                    drop_model.set_value(add_iter, 4, gtk.STOCK_GO_UP)
                else:
                    drop_model.set_value(add_iter, 4, "")
        # on droule l'arbre des composants
        self.dropbox.collapse_all()
        path = drop_model.get_path(add_iter)
        self.dropbox.expand_to_path(path)
        column = self.comp_tree.get_column(1)
        # timeout : bidouille pour viter que le treeview ne reprenne le focus
        self.dropbox.scroll_to_cell(path,column)
        

    def toggle_composant(self, tree, event):
        """callback lorsque l'on clique sur un composant/paquet
        """
        self.update_status("")
        # si c'est un double click, on ajoute/supprime l'lment dans le module
        if event.type ==  gtk.gdk._2BUTTON_PRESS:
            # on recherche le composant slectionn
            store, iter_sel = tree.get_selection().get_selected()
            # on continue seulement si il y a une checkbox
            if store.get_value(iter_sel, 3):
                sel = store.get_value(iter_sel, 2)
                if sel:
                    if self.rel == False:
                        # elle est coche -> supression
                        name = store.get_value(iter_sel, 1)
                        # on vrifie les dpendances
                        broken_deps = []
                        deps = eolepackdb.get_rev_depends_for_composant(name)
                        comps = [comp[1] for comp in eolepackdb.get_composant_from_module(self.edited_module)]
                        for dep in deps:
                            if dep in comps:
                                broken_deps.append(dep)
                        if broken_deps != []:
                            # avertissement de dpendance casse
                            dial = self.display_popup(_("Following dependancies will be broken, proceed ?\n\n\t %s") \
                                    % '\n\t'.join(broken_deps), 'Confirm')
                            response = dial.run()
                            dial.destroy()
                            if response != gtk.RESPONSE_YES:
                                # on annule
                                return
                        store.set_value(iter_sel, 2, False)
                        self.remove_dropbox(name)
                        # on supprime dans la base
                        eolepackdb.del_composant_from_module(self.edited_module, name)
                        self.data_modified(True)
                else:
                    # non coche -> ajout
                    iters = [iter_sel]
                    name = store.get_value(iter_sel, 1)
                    paq_exist = eolepackdb.get_paquet_from_composant(name)
                    if paq_exist == []:
                        nopack = 'x'
                    else:
                        nopack = None
                    # on recherche les dpendances dans la base
                    depends = eolepackdb.get_depends(name)
                    if depends != []:
                        dial=self.display_popup(u"dpendances de %s:\n\n %s\n\n continuer ?" % (name, ", ".join(depends)), type='Confirm')
                        response = dial.run()
                        dial.destroy()
                        if response == gtk.RESPONSE_YES:
                            # demande confirme, on active les dpendances
                            for depend in depends:
                                if self.rel == False:
                                    # mode module
                                    iter_dep = self.find_item(store,{1:depend,2:False}, search_iter=store.get_iter_root(), depth=1)
                                    if iter_dep != None:
                                        iters.append(iter_dep)
                        else:
                            # commande annule
                            return

                    # traitement des composants  cocher
                    for iter_check in iters:

                        org_iter = iter_check
                        store.set_value(iter_check, 2, True)
                        name = store.get_value(iter_check, 1)

                        # on cherche la famille
                        while store.iter_parent(iter_check) != None:
                            fam = store.get_value(store.iter_parent(iter_check), 1)
                            iter_check = store.iter_parent(iter_check)
                        if self.rel == False:
                            eolepackdb.module_add_composant(self.edited_module,name)
                            self.data_modified(True)
                            self.append_dropbox(name, fam, org_iter, nopack)
                        else:
                            # pour un paquet, on dcompose le nom en 'paquet, version, rvision'
                            paq = store.get_value(org_iter, 1)
                            comp_iter=store.iter_parent(org_iter)
                            nom = store.get_value(comp_iter, 1)
                            version = store.get_value(org_iter, 5)
                            revision = store.get_value(org_iter, 6)
                            # une seule version doit tre slectionne pour un composant donn
                            # on parcourt tous les paquet du composant pour les dselectionner si besoin
                            iter_max = start_iter = store.iter_children(comp_iter)
                            
                            if store.get_value(iter_max, 1) != store.get_value(org_iter, 1):
                                dialog = self.display_popup(_("Use an old revision ?"), 'Confirm')
                                response = dialog.run()
                                dialog.destroy()
                                if response == gtk.RESPONSE_NO:
                                    return
                                                            
                            while start_iter != None:
                                if store.get_value(start_iter, 2):
                                    store.set_value(start_iter, 2, False)
                                    self.remove_dropbox(store.get_value(start_iter,1))
                                start_iter=store.iter_next(start_iter)
                            # on slectionne le paquet demand
                            store.set_value(org_iter, 2, True)
                            self.append_dropbox(paq, fam, org_iter)
                            # on active cette version du paquet
                            eolepackdb.release_select_paquet(self.edited_module, nom, version, revision)
                            self.data_modified(True)
                        


    ###############################
    # ajout/suppression de donnes

    def add_module(self, *args):
        """cre un nouveau module/release
        """
        self.update_status("")
        if self.rel == False:
            # mode module
            # remplissage de la combobox pour les modules dispos (copie de module existant)
            combo = self.widgets.get_widget('combo_copy_mod')
            combo.get_child().set_editable(False)
            combo.set_model(self.module_tree.get_model())
            combo.set_text_column(1)
            
            self.add_mod_box.show()
            response = self.add_mod_box.run()
            # saisie des champs
            mod_text = self.widgets.get_widget('entry_mod_name').get_text()
            mod_desc = self.widgets.get_widget('entry_mod_desc').get_text()
            mod_maint = self.widgets.get_widget('entry_mod_maint').get_text()
            copy_mod = combo.get_child().get_text()
            # remise  0 du dialogue de saisie
            self.add_mod_box.hide()
            self.widgets.get_widget('entry_mod_name').set_text('')
            self.widgets.get_widget('entry_mod_desc').set_text('')
            self.widgets.get_widget('entry_mod_maint').set_text('')

            if response == gtk.RESPONSE_OK:
                if mod_text != '':
                    try:
                        # si un module 'template' est donn, on le copie
                        if copy_mod != '':
                            eolepackdb.copy_module(copy_mod, mod_text, mod_desc, mod_maint)
                        else:
                            eolepackdb.add_module(mod_text, mod_desc, mod_maint)
                        id_mod = eolepackdb.get_module(mod_text)
                        # on l'ajoute  la liste des modules de cette session (on peut le supprimer)
                        self.new_modules.append(id_mod[0][0])
                        self.data_modified(True)
                        self.update_status(_("Module added"))
                    except Exception, e:
                        print e
                        self.update_status(_("Database Error"))
                    self.update_module()
                else:
                    self.update_status(_("Missing fields"))
        else:
            # mode release
            model, cur_iter = self.mod_selection.get_selected()
            # on regarde le module slectionn
            if model.iter_parent(cur_iter) == None:
                id_mod = model.get_value(cur_iter, 0)
            else:
                # si on tait sur une release, on cherche le nom du module parent
                id_mod = model.get_value(model.iter_parent(cur_iter), 0)
                
            self.add_rel_box.show()
            response = self.add_rel_box.run()
            # saisie des champs
            major = self.widgets.get_widget('rel_entry_major').get_text()
            minor = self.widgets.get_widget('rel_entry_minor').get_text()
            # remise  0 du dialogue
            self.add_rel_box.hide()
            self.widgets.get_widget('rel_entry_major').set_text('')
            self.widgets.get_widget('rel_entry_minor').set_text('')
            # cration de la release
            if response == gtk.RESPONSE_OK:
                if major != '' and minor != '':
                    try:
                        eolepackdb.add_release(id_mod, major, minor)
                        self.data_modified(True)
                        id_rel = eolepackdb.get_id_from_release(id_mod, major, minor)
                        # on l'ajoute  la liste des releases de cette session (on peut la supprimer)
                        self.new_release.append(id_rel[0])
                        list_pack=eolepackdb.get_paquet_from_module(id_mod)
                        dic_pack={}
                        for pack in list_pack:
                            dic_pack[pack[0]]=[pack[0], pack[1], str(pack[2])]

                        for key, value in dic_pack.items():
                            eolepackdb.release_select_paquet(id_rel[0], key, value[1], value[2])
                        list_pack=["-".join(pack) for pack in dic_pack.values()]
                        model=self.comp_tree.get_model()
                        self.run_tree(model, dic_pack.values(), model.get_iter_root(), self.dropbox.get_model())
                        self.update_status(_("Release added"))
                        
                    except Exception, e:
                        print e
                        self.update_status(_("Database Error"))
                    popup = self.display_popup(_("Reloading Modules"), 'Message')
                    rundial(popup)
                    self.update_module()
                    self.update_composants()
                    popup.destroy()
                else:
                    self.update_status(_("Missing fields"))


    def del_module(self, *args):
        """supprime un module/release
        """
        self.update_status("")
        if self.rel == False:
            model, iter_del = self.mod_selection.get_selected()
            if iter_del == None:
                return
            id_mod = model.get_value(iter_del, 0)
            # on permet la suppression si le module a t cr dans cette session
            if id_mod in self.new_modules:
                dial = self.display_popup(_("Confirm Module Deletion ?"), 'Confirm')
                response = dial.run()
                dial.destroy()
                if response == gtk.RESPONSE_YES:
                    # supression
                    eolepackdb.del_module(id_mod)
                    self.update_module()
                    self.data_modified(True)
                    self.widgets.get_widget('button_iso').set_sensitive(False)
                    self.update_status(_("Module deleted"))
            else:
                dial = self.display_popup(_("Cannot delete old module"), 'Error')
                response = dial.run()
                dial.destroy()
        else:
            model, cur_iter = self.mod_selection.get_selected()
            # on vrifie qu'on n'a pas slectionn un module
            if model.iter_parent(cur_iter) != None:
                id_rel = model.get_value(cur_iter, 0)
                # on vrifie que c'est une nouvelle release 
                if id_rel in self.new_release:
                    dial = self.display_popup(_("Confirm Release Deletion ?"), 'Confirm')
                    response = dial.run()
                    dial.destroy()
                    if response == gtk.RESPONSE_YES:
                        eolepackdb.del_release(id_rel)
                        self.update_module()
                        self.data_modified(True)
                        self.widgets.get_widget('button_iso').set_sensitive(False)
                        self.update_status(_("Release deleted"))
                else:
                    dial = self.display_popup(_("Cannot delete old release"), 'Error')
                    response = dial.run()
                    dial.destroy()

    #########################
    # Configuration spell

    def do_config(self, * args):
        # Recherche du composant slectionn
        self.update_status("")
        # Il faut rcuprer l'lement slectionn dans la liste
        store, iter_sel = self.comp_selection.get_selected()
        if iter_sel is None:
            return
        comp_name = store.get_value(iter_sel, 1)
        # rcupration  distance du contenu
        try:
            conf = self.compiler.get_conf(comp_name)
        except socketerror:
            dial = self.display_popup(_('Connection refused'), 'Error')
            dial.run()
            dial.destroy()
            return
        except Exception,e:
            print str(e)
            dial = self.display_popup(_("Error fetching configuration file"), 'Error')
            response = dial.run()
            dial.destroy()
            return
        s=StringIO()
        s.write(xmlrpclib.base64.decodestring(conf))
        s.seek(0)
        # update du parser de configuration
        self.conf_parser.load(s)
        self.conftree.expand_all()
        # recherche des dpendances du composant
        depends = eolepackdb.get_depends(comp_name)
        self.widgets.get_widget('vbox_depends').set_sensitive(len(depends) > 0)
        # update de la combobox des dpendances
        modeldep = self.confcombo.get_model()
        modeldep.clear()
        for depend in depends:
            add_iter = modeldep.append()
            modeldep.set_value(add_iter,0,depend)
        self.widgets.get_widget('checkdevel').set_active(self.conf_parser.devel)
        # slectionne le premier item de la liste
        if len(depends) > 0:
            self.confcombo.child.set_text(depends[0])
        self.confbox.show()

    def add_destroy(self, *args):
        """ajoute un fichier  supprimer dans l'archive binaire
        """
        # rcupration du nom de fichier
        destroy = self.widgets.get_widget('entry_conf').get_text()
        if destroy != '':
            self.conf_parser.add_destroy(destroy)
            self.conftree.expand_all()

    def add_optional(self, *args):
        """ajoute une dpendance optionelle
        """
        # nom de la dpendance a ajouter
        optional = self.confcombo.get_child().get_text()
        if optional != '':
            self.conf_parser.add_optional(optional)
            self.conftree.expand_all()

    def toggle_devel(self, *args):
        """prend en compte le choix de faire un paquet devel
        """
        devel = self.widgets.get_widget('checkdevel').get_active()
        self.conf_parser.update_devel(devel)

    def del_option(self, *args):
        """supprime un item de la configuration du spell
        """
        # rcupration de l'item slectionn
        store, iter_del = self.conftree.get_selection().get_selected()
        if iter_del is not None:
            self.conf_parser.remove_iter(iter_del)

    def valid_conf(self, *args):
        """valide la configuration d'un composant
        """
        # Il faut rcuprer l'lement slectionn dans la liste
        store, iter_sel = self.comp_selection.get_selected()
        if iter_sel is None:
            return
        comp_name = store.get_value(iter_sel, 1)
        conf = self.conf_parser.update_conf()
        if conf != "":
            # save configuration on server
            res = self.compiler.save_conf(comp_name, xmlrpclib.base64.encodestring(conf))
            if res != "":
                dial = self.display_popup(_("Error saving configuration"), 'Error')
                response = dial.run()
                dial.destroy()
                return True
            
        self.confbox.hide()

    def hide_conf(self, *args):
        """cache la fentre de configuration
        """
        self.confbox.hide()
        return True
        
    #########################
    # Compilation/gnration
    
    def do_compile(self, * args):
        """lance la compilation d'un composant
        """
        self.update_status("")
        # Il faut rcuprer l'lement slectionn dans la liste
        store, iter_sel = self.comp_selection.get_selected()
        # en mode release, si paquet slectionn, on prend le composant
        comp_name = store.get_value(iter_sel, 1)
        if self.rel == True:
            if store.get_value(iter_sel, 3):
                comp_name = store.get_value(store.iter_parent(iter_sel),1)
                path_sel = store.get_path(store.iter_parent(iter_sel))
        else:
            path_sel = store.get_path(iter_sel)
        try:
            dialsearch = self.display_popup(_("Searching Dependencies"), 'Message')
            rundial(dialsearch)
            res = self.compiler.check_depends(comp_name)
            dialsearch.destroy()
        except socketerror:
            # FIXME : amliorer ce bout de code !
            dialsearch.destroy() # dgager le popup prcdent
            dial = self.display_popup(_('Connection refused'), 'Error')
            dial.run()
            dial.destroy()
            return
        
        if len(res) > 1:
            dial = self.display_popup(_("components to compile : \n- %s \nproceed to compilation ?") % "\n- ".join(res), 'Confirm')
            response = dial.run()
            dial.destroy()
            if response != gtk.RESPONSE_YES:
                res = []
        if res == []:
            # FIXME : a ne devrait pas arriver
            dial = self.display_popup(_("Component not found"), 'Error')
            dial.run()
            dial.destroy()
            return
        else:
            ## FIXME : remplacer le popup par la progess bar voir code ISO!!!
            dial = self.display_popup(_("Compiling ...\n- %s") % "\n- ".join(res), 'Message')
            rundial(dial)

            self.in_thread = True
            thread.start_new_thread(self.run_compil, (res,))
            
            while self.in_thread:
                sleep(1)
            dial.destroy()
            if self.thread_ok:
                # compilation termine avec succs
                dial = self.display_popup(_("Component compiled"))
                dial.run()
                dial.destroy()
                # on recharge le module
                # pour retrouver l'arbre ouvert au mme endroit
                self.need_save = True
                self.update_module_name(self.mod_selection)
                iter
                iter_dep = store.get_iter(path_sel)
                # FIXME : TypeError: iter should be a GtkTreeIter !!!
                self.expand_to_iter(store, iter_dep)
            else:
                # should not append : problme si self.thread_msg == ""
                dial = self.display_popup(self.thread_msg, 'Error')
                dial.run()
                dial.destroy()
            
    def run_compil(self, res):
        """lancement de la compilation (thread)
        """
        try:
            self.thread_msg = self.compiler.do_compile(res)
            if self.thread_msg.lower() == "ok":
                self.thread_ok = True
            else:
                self.thread_ok = False
            self.in_thread = False
            return
        except Exception, e:
            self.thread_ok = False
            self.thread_msg = str(e)
            self.in_thread = False
            return

    def create_iso(self, * args):
        """Lance la gnration de l'image
        """
        self.update_status("")
        if self.rel == False:
            # non disponible en mode module
            return
        # on vrifie que les modifs sont valides
        if self.need_save == True:
            dial = self.display_popup(_("Save changes before generating"), 'Error')
            response = dial.run()
            dial.destroy()
            return

        store, iter_sel = self.mod_selection.get_selected()
        id_rel = store.get_value(iter_sel,0)
        release = store.get_value(iter_sel,1)
        mod, version = release.split('-')
        maj, min = version.split('.')
        try:
            # on vrifie l'intgrit de la release
            res = self.compiler.check_paqs(mod, maj, min)
        except socketerror:
            dial = self.display_popup(_('Connection refused'), 'Error')
            dial.run()
            dial.destroy()
            return
        if res[0] != "":
            dial = self.display_popup(_("missing packets") + " :\n\n" + res[0], 'Error')
            response = dial.run()
            dial.destroy()
            return

        dial = self.display_popup(_("Generate ISO ?"), 'Confirm')
        response = dial.run()
        dial.destroy()
        if response != gtk.RESPONSE_YES:
            # Nooooooooooooon
            self.update_status(_("Generation aborted"))
            return
        else:
            
            self.update_status("")
            #dial = self.display_popup(_("generating iso"), 'Message')
            #rundial(dial)
            dial = self.display_progress(_("generating iso"))
            dial.show()
            
            # on n'a pas le droit de crer de fentre dans le thread !
            ok_dial = self.display_popup(_("iso created"))
            error_dial = self.display_popup('', 'Error')
            thread.start_new_thread(self.run_iso, (id_rel, dial, ok_dial, error_dial))
            return
            
    def run_iso(self, id_rel, dial, ok_dial, error_dial):
        """gnration de l'ISO (thread)
        """
        try:
            msg = self.compiler.create_iso(id_rel)
            dial.destroy()
            self.thread_finished = True
            if msg == "OK":
                gtk.threads_enter()
                ok_dial.run()
                gtk.threads_leave()
            else:
                gtk.threads_enter()
                error_dial.set_markup(msg)
                error_dial.run()
                gtk.threads_leave()
            ok_dial.destroy()
            error_dial.destroy()
            return

        except Exception, e:
            gtk.threads_enter()
            error_dial.set_markup(str(e))
            error_dial.run()
            gtk.threads_leave()
            ok_dial.destroy()
            error_dial.destroy()
            return
            
    ########################
    # fonctions utilitaires

    def expand_tree(self, tree_selection, *args):
        """affiche le composant voulu dans la fenetre des composants
        """
        store, iter_sel = tree_selection.get_selected()
        if iter_sel != None:
            # rcupration de l'iter correspondant
            iter_comp = store.get_value(iter_sel,3)
            if iter_comp is not None:
                self.expand_to_iter(store,iter_comp)

    def expand_to_iter(self, store, iter_comp):
        """affiche l'iter demand dans le treestore des composants
        """
        # on droule l'arbre des composants
        self.comp_tree.collapse_all()
        path = self.comp_tree.get_model().get_path(iter_comp)
        self.comp_tree.expand_to_path(path)
        column = self.comp_tree.get_column(1)
        # timeout : bidouille pour viter que le treeview ne reprenne le focus
        gobject.timeout_add(10, lambda: self.comp_tree.grab_focus())
        self.comp_tree.scroll_to_cell(path,column)
        self.comp_tree.set_cursor(path, column)

    def update_status(self, text=None):
        """met  jour le texte de la status-bar
        """
        context = self.status.get_context_id('status')
        if text != None:
            self.status.push(context, text)

    def set_label_title(self, text, color='#000000'):
        """met  jour le titre affich
	couleurs choisies :
	   - mode module : #2B57D9 (bleu)
	   - mode release : #c9513d (rouge)
        """
        title = self.widgets.get_widget('label_title')
        title.set_markup('<span foreground="%s" font_desc="monospace bold 20">%s</span>' % (color, text))
    
    def data_modified(self,bool=True):
        self.need_save = bool
        # on dgrise les boutons commit et rollback
        self.widgets.get_widget('commit').set_sensitive(bool)
        self.widgets.get_widget('rollback').set_sensitive(bool)

    def quit(self, *args):
        """quitte le programme
        """
        if self.need_save == True:
            dial = self.display_popup(_("Quit without saving ?"), 'Confirm')
            response = dial.run()
            dial.destroy()
            if response == gtk.RESPONSE_NO:
                return True
            # FIXME : faire un rollback si on sort ?
        gtk.main_quit()

    def display_popup(self, text, type=''):
        """affiche un message
        @param type: ''        -> message d'info
                     'Message' -> message d'info sans bouton
                     'Error'   -> message d'erreur
                     'Confirm' -> question oui/non
        """
        if type == 'Error':
            msgtype = gtk.MESSAGE_ERROR
            buttons = gtk.BUTTONS_OK
        elif type == 'Confirm':
            msgtype = gtk.MESSAGE_QUESTION
            buttons = gtk.BUTTONS_YES_NO
        elif type == 'Message':
            msgtype = gtk.MESSAGE_INFO
            buttons = gtk.BUTTONS_NONE
        else:
            msgtype = gtk.MESSAGE_INFO
            buttons = gtk.BUTTONS_OK
            
        dialog = gtk.MessageDialog(self.mainwindow, gtk.DIALOG_MODAL, msgtype, buttons, text)
        return dialog
    
    def display_progress(self, text):
        """
        affichage de la progress bar
        """
        self.thread_finished = False
        fenetre = gtk.Dialog()
        #fenetre.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_DIALOG)
        #fenetre.set_resizable(True)
        fenetre.set_title(text)
        fenetre.set_default_size(340,15)
        fenetre.set_border_width(0)
        # Creation d'un objet alignement au centre
        align = gtk.Alignment(0.5, 0.5, 0.5, 0.5)
        fenetre.vbox.pack_start(align,True, True, 0)
        # Creation de la barre de progression en utilisant l'ajustement
        barreprogression = gtk.ProgressBar()
        barreprogression.set_pulse_step(0.025)
        align.add(barreprogression)
        gtk.timeout_add (50, self.pulse, barreprogression)
        barreprogression.show()
        align.show()
        return fenetre
        
    def commit(self, *args):
        """valide les modifications de la base de donnes
        """
        self.update_status("")
        dial = self.display_popup(_("Confirm DB Commit ?"), 'Confirm')
        response = dial.run()
        dial.destroy()
        if response == gtk.RESPONSE_YES:
            eolepackdb.end_transaction()
            self.data_modified(False)
            
    def rollback(self, *args):
        """annule toutes les modifications non commites dans la base de donnes
        """
        self.update_status("")
        dial = self.display_popup(_("Rollback all transactions ?"), 'Confirm')
        response = dial.run()
        dial.destroy()
        if response == gtk.RESPONSE_YES:
            # on fait un rollback
            eolepackdb.end_transaction(True)
            self.data_modified(False)
            # on relit toutes les donnes
            self.update_module()
            self.update_composants()
            self.dropbox.get_model().clear()

    def pulse(self, bar):
        if self.thread_finished == False:
            bar.pulse()
            return True
        return False
       

if __name__=='__main__':
    fileconf = os.path.dirname(os.path.abspath(__file__)) + '/eolebase.conf'
    gladefile = os.path.dirname(os.path.abspath(__file__)) + '/edif/edif.glade'
    rc_file = os.path.dirname(os.path.abspath(__file__)) + '/edif/eole.rc'
    e = Edif(gladefile, False, fileconf, rc_file)
    # initialisation des threads gtk
    gtk.threads_init()
    gtk.threads_enter()
    gtk.main()
    gtk.threads_leave()
