# -*- coding: utf-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# authentification ldap
#
###########################################################################

import ldap
server = "diff-eole.ac-dijon.fr"

def ldapsearch(filtre, attrlist=[]):
    """
    recherche dans l'annuaire
    """
    query = ldap.open(server)
    query.simple_bind_s()
    result = query.search_s("o=gouv,c=fr", ldap.SCOPE_SUBTREE, filtre, attrlist)
    query.unbind()
    return result

def authenticate(user, password):
    """
    tentative de validation d'un couple login/mdp
    """
    if user == '' or password == '':
        return False
    # récupération du dn
    res = ldapsearch("""uid=%s""" % user, ['uid'])
    if res == []:
        return False
    try:
        query = ldap.open(server)
        # bind avec le compte utilisateur
        query.simple_bind_s(res[0][0], password)
        return True
    except ldap.INVALID_CREDENTIALS:
        return False        

