#!/usr/bin/env python
# -*- coding: utf-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Serveur xmlrpc pour la compilation des paquets EoleNg
#
###########################################################################

from twisted.web import xmlrpc, server
from eolepack.pack import pack
from eolepack.delete import delete_package
import time
from glob import glob
from eolepack.config import COMPIL_PATH

class ServerXMLRPC(xmlrpc.XMLRPC):

    def xmlrpc_pack(self, paquet, version, distribution, user, password,
		    tags=None, branches=None, revision=None, epoch=None, changelog=None):
        # serialisation de la chaine None pour le xmlrpc
        for var in ['tags','branches','revision','epoch','changelog']:
            if eval(var) == 'None':
                exec(var+"=None")

        """Return all passed args."""
        return pack(paquet, version, distribution, user, password, tags, branches, revision, epoch, changelog)

    def xmlrpc_delete_package(self, paquet, version, dist_eole):
	return delete_package(paquet, version, dist_eole)

    def xmlrpc_get_rapportfile(self, name, version):
        rapportfile = glob('%s/%s-%s-*/rapport.txt' % (COMPIL_PATH, name, version))
        if len(rapportfile) != 1:
            return ""
        else:
            return file(rapportfile[0]).read()

if __name__ == '__main__':
    from twisted.internet import reactor
    print
    print time.ctime()
    print "démarrage du serveur de compilation"
    print
    r = ServerXMLRPC()
    reactor.listenTCP(7080, server.Site(r))
    reactor.run()
